#define INCL_DOS

#include <os2.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>


#define TEXTLEN 80

char * _fastcall fgetsx (char *str,int num,int handle);




int _cdecl main (void) {

    char s[TEXTLEN + 3],lastchar = 0;
    struct _fuseridx {
        char firstchar;
        long pos;
    } fux;
    int         f,fx;
    long        low;
    struct stat buf;


    if(stat("FIDOUSER.LST",&buf)) {
        printf("\nCan't find FIDOUSER.LST\n");
        return 1;
    }

    f = sopen("FIDOUSER.LST",O_RDONLY | O_BINARY, SH_DENYNO); /* open it */
    if(f == -1) {
        printf("\nCan't open FIDOUSER.LST\n");
        return 1;
    }

    fx = sopen("FIDOUSER.IDX",O_CREAT | O_RDWR | O_BINARY,SH_DENYWR,S_IWRITE | S_IREAD);
    if(fx == -1) {
        printf("\nCan't open FIDOUSER.IDX\n");
        close(f);
        return 1;
    }

    printf("\nReindexing FIDOUSER.LST...\n");

    DosNewSize(fx,0L);
    lseek(fx,0L,SEEK_SET);
    write(fx,&buf.st_size,sizeof(long));
    write(fx,&buf.st_mtime,sizeof(long));
    while(!eof(f)) {
        low = tell(f);
        if(!fgetsx(s,TEXTLEN+1,f)) break;
        if(*s != (char)' ') {
            if(toupper(*s) != (int)lastchar) {
                lastchar = (char)toupper(*s);
                fux.firstchar = lastchar;
                fux.pos = low;
                write(fx,&fux,sizeof(struct _fuseridx));
            }
        }
    }

    close(f);
    close(fx);

    return 0;
}



char * _fastcall fgetsx (char *str,int num,int handle) {

    register char *p;
    long pos;
    int x;


    if(eof(handle)) {
        *str = 0;
        return NULL;
    }
    pos = tell(handle);
    x = read(handle,str,num - 1);
    if(x < 1) {
        *str = 0;
        return NULL;
    }
    str[x] = 0;
    p = str;
    while(*p && *p != '\r' && *p != '\n') p++;
    if(!*p) return str;
    if(*p == '\r') {
        *p = '\n';
        if (p[1] == '\n') {
            p++;
            *p = 0;
        }
    }
    p++;
    *p = 0;
    lseek(handle,pos + ((long)((unsigned int)p - (unsigned int)str)),SEEK_SET);
    return str;
}
